﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Media.Animation;
using System.Windows.Media.Media3D;

namespace _3DImageViewer
{
    /// <summary>
    /// Interaction logic for Page1.xaml
    /// </summary>
    public partial class Viewer : Page
    {
        double x;
        public Viewer()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DoubleAnimation dblAnim;
            bool front = true;
            if (rotation.Angle >= 0 && rotation.Angle < 180)
                dblAnim = new DoubleAnimation(rotation.Angle, 180, new Duration(TimeSpan.FromSeconds(1)), FillBehavior.Stop);
            else
            {
                dblAnim = new DoubleAnimation(rotation.Angle, 0, new Duration(TimeSpan.FromSeconds(1)), FillBehavior.Stop);
                front = false;
            }
            rotation.BeginAnimation(AxisAngleRotation3D.AngleProperty, dblAnim);
            if (front)
                rotation.Angle = 180;
            else
                rotation.Angle = 0;
        }

        private void grd_MouseUpDown(object sender, MouseButtonEventArgs e)
        {
            grd.Focus();
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                x = Mouse.GetPosition(sender as IInputElement).X;
                grd.MouseMove += new MouseEventHandler(grd_MouseMove);
            }
            else
                grd.MouseMove -= new MouseEventHandler(grd_MouseMove);
        }

        private double rotationCheck(double d)
        {
            if (d > 360 || d < -360) return d - (360 * Convert.ToInt32(d / 360));
            else return d;
        }

        void grd_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                rotation.Angle = rotationCheck(rotation.Angle +
                    ((Mouse.GetPosition(sender as IInputElement).X - x) * scale.ScaleX));
                x = Mouse.GetPosition(sender as IInputElement).X;
            }
        }
    }
}
